/* ColPrefs.c
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Farbeinstellungen */

#include "Constants.h"
#include "ColPrefs.h"
#include "Preferences.h"
#include "../Forms/MainWindow.h"

int oldcolnum,
    backcol[COL_MAX+1][3],
    precol[COL_MAX+1][3]=
                 { 
                   {190,190,190},  // COL_BG
                   {  0,  0,  0},  // COL_TEXT
                   {145,100, 10},  // COL_SERVER
                   {142,  0,  0},  // COL_QUERY
                   {255,255,255},  // COL_HILIGHT
                   { 23,109,162},  // COL_CTCP
                   {  0,100,  0},  // COL_DCC
                   {150,  0,150},  // COL_PRG
                   {  0,  0,100},  // COL_ACTION
                   {  0,  0,  0},  // COL_PREVIEW
                   {  0,  0,  0},  // COL_PREVIEWBG
                   {255,255,255},  // COL_DIR
                   {  0,  0,  0},  // COL_FI LE
                   { 40,170,175},  // COL_DCCGET
                   {170,  0,  0}   // COL_DCCSEND
                 };

extern struct preferences prefs;
extern FD_MainWindow *mainform;

void getprecols()
{
  int colx,coly;

  for(colx=0;colx<COL_MAX;colx++)                                 // Standardfarben laden
  {
    for(coly=0;coly<3;coly++) prefs.color[colx][coly]=precol[colx][coly];
  } // endfor
}

void getbackcols()
{
  int colx,coly;

  for(colx=0;colx<COL_MAX;colx++)                              // Standardfarben laden
  {
    for(coly=0;coly<3;coly++) backcol[colx][coly]=prefs.color[colx][coly];
  } // endfor
}

void setrgb(FD_ColorWindow *colorwindow,int r,int g,int b,int bg)
{
  fl_mapcolor((bg) ? COL_PREVIEWBG : COL_PREVIEW,r,g,b);
  fl_redraw_object(colorwindow->ColorPad);
  fl_redraw_object(colorwindow->SampleText);
}

void setsliders(FD_ColorWindow *colorwindow,int r,int g,int b)
{
  fl_set_slider_value(colorwindow->RedSlider,(double)r);
  fl_set_slider_value(colorwindow->GreenSlider,(double)g);
  fl_set_slider_value(colorwindow->BlueSlider,(double)b);
}

void setvalues(FD_ColorWindow *colorwindow,int bg)
{
  char digits[3],hex[8];
  int r,g,b;

  r=(int)fl_get_slider_value(colorwindow->RedSlider);
  g=(int)fl_get_slider_value(colorwindow->GreenSlider);
  b=(int)fl_get_slider_value(colorwindow->BlueSlider);
  sprintf(digits,"%d",r);
  fl_set_input(colorwindow->RedInput,digits);
  sprintf(digits,"%d",g);
  fl_set_input(colorwindow->GreenInput,digits);
  sprintf(digits,"%d",b);
  fl_set_input(colorwindow->BlueInput,digits);
  setrgb(colorwindow,r,g,b,bg);

  sprintf(hex,"#%0.2x%0.2x%0.2x",r,g,b);
  fl_set_object_label(colorwindow->HexCode,hex);
}

void setcols(FD_ColorWindow *colorwindow,int r,int g,int b,int bg)
{
  setsliders(colorwindow,r,g,b);
  setvalues(colorwindow,bg);
}

FD_ColorWindow *colorcontrol(FD_ColorWindow *colorwindow,FL_OBJECT *select)
{
  int quit,colnum,colx,coly;

  quit=0;
  colnum=fl_get_browser(colorwindow->ColorSelector);
  if(colnum==0)
  {
    fl_select_browser_line(colorwindow->ColorSelector,2);
    colnum=2;
    oldcolnum=2;
    setcols(colorwindow,prefs.color[1][0],prefs.color[1][1],prefs.color[1][2],0);
  }

  if(select==colorwindow->ColorSelector || select==colorwindow->Save)
  {
    prefs.color[oldcolnum-1][0]=(int)fl_get_slider_value(colorwindow->RedSlider);
    prefs.color[oldcolnum-1][1]=(int)fl_get_slider_value(colorwindow->GreenSlider);
    prefs.color[oldcolnum-1][2]=(int)fl_get_slider_value(colorwindow->BlueSlider);
    setcols(colorwindow,prefs.color[colnum-1][0],prefs.color[colnum-1][1],prefs.color[colnum-1][2],(colnum==1));
    oldcolnum=colnum;

    if(select==colorwindow->Save)
    {
      writeprefs(&prefs);
      for(colx=0;colx<COL_MAX;colx++) fl_mapcolor(COL_BG+colx,prefs.color[colx][0],prefs.color[colx][1],prefs.color[colx][2]);
      fl_redraw_object(mainform->ChannelText);
      quit=1;
    }
  }

  if(select==colorwindow->RedSlider) setvalues(colorwindow,(colnum==1));
  if(select==colorwindow->GreenSlider) setvalues(colorwindow,(colnum==1));
  if(select==colorwindow->BlueSlider) setvalues(colorwindow,(colnum==1));

  if(select==colorwindow->RedInput ||
     select==colorwindow->GreenInput ||
     select==colorwindow->BlueInput)
  {
    int r,g,b;

    r=atoi(fl_get_input(colorwindow->RedInput));
    g=atoi(fl_get_input(colorwindow->GreenInput));
    b=atoi(fl_get_input(colorwindow->BlueInput));

    setsliders(colorwindow,r,g,b);
    setvalues(colorwindow,(colnum==1));
  }

  if(select==colorwindow->Undo) setcols(colorwindow,prefs.color[colnum-1][0],prefs.color[colnum-1][1],prefs.color[colnum-1][2],(colnum==1));
  if(select==colorwindow->Default) setcols(colorwindow,precol[colnum-1][0],precol[colnum-1][1],precol[colnum-1][2],(colnum==1));

  if(select==colorwindow->Cancel)
  {
    for(colx=0;colx<COL_MAX;colx++)                              // Standardfarben laden
    {
      for(coly=0;coly<3;coly++) prefs.color[colx][coly]=backcol[colx][coly];
    }
    quit=1;
  }

  if(quit==0) return colorwindow;
  else
  {
    fl_hide_form(colorwindow->ColorWindow);
    return 0;
  }
}
