/* DCC.h
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Die Datenstruktur fr DCC-Transfers */

#define DCC_SEND            0
#define DCC_GET             1
#define DCC_CHAT            2

#define STATUS_PENDING      0
#define STATUS_CONNECTING   1
#define STATUS_FORKING      2
#define STATUS_RUNNING      3
#define STATUS_COMPLETE     4
#define STATUS_REMOVE       5
#define STATUS_FAILED     255

#include <forms.h>

#include "Constants.h"
#include "Channel.h"
#include "ErrorLog.h"
#include "Preferences.h"
#include "FileSelector.h"

#include "../Forms/DCCSendQuestion.h"
#include "../Forms/DCCRecipient.h"
#include "../Forms/DCCGetStatus.h"

struct dccdata
{
  struct dccdata *next;
  struct dccdata *prev;
  int memid;            // Shared Memory-ID
  int type;
  int handle;           // Fr DCC SEND: Dateihandle
  int socket;
  int socket2;          // Fr DCC SEND
  int status;
  int connection;       // Interne Verbindungsnummer
  int stallcount;       // Anzahl der Sekunden in denen nichts empfangen wurde
  unsigned long ip;
  long port;
  long packetsize;
  long filesize;
  long actualsize;
  long acked;           // Acknowledge
  long oldsize;         // Fr Stall-Check
  long starttime;       // Fr die CPS-Berechnung
  char sender[NICKLEN];    // Fr DCC_GET
  char recipient[NICKLEN]; // Fr DCC_SEND
  char name[1024];
  char server[16];
  char find[514];
};

struct dccdisplay
{
  FL_OBJECT *control;
  FL_OBJECT *sender;
  FL_OBJECT *name;
  FL_OBJECT *bytecount;
  FL_OBJECT *cps;
  FL_OBJECT *processbar;
};

FD_DCCSend *opendccsend();
FD_RecipientWindow *openrecipient();
FD_DCCGetStatus *opendccget();
void dccgetadd(char *,char *,char *,unsigned long,long,long);
void dccsendadd(char *,char *,char *);
FD_DCCSend *dccsendcontrol(FD_DCCSend *,FL_OBJECT *);
FD_DCCGetStatus *dccgetcontrol(FD_DCCGetStatus *,FL_OBJECT *);
int connectdcc(struct dccdata *);
void handledcc(FL_OBJECT *);
