/* Events.h
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Die Datenstrukturen fr Ereignisse. */

#ifndef EVENTS_H
#define EVENTS_H

#define EVENT_NONE        -1
#define EVENT_JOIN         0
#define EVENT_PART         1
#define EVENT_ISON         2
#define EVENT_TEXT         3
#define EVENT_DCCREQUEST   4
#define EVENT_DCCDONE      5
#define EVENT_QUERY        6
#define EVENT_MODE         7
#define EVENT_INVITE       8
#define EVENT_NICK         9

#include <forms.h>

#include "Lists.h"
#include "Preferences.h"

#include "../Forms/EventPrefs.h"

struct event
{
  char *name;
  char *parameter;
  char *text;
  char *script;
  char *sound;
  int type;
  int doneonce;
};

struct sound
{
  char *rawdata;
  long length;
  long speed;
  char bits;
  char stereo;
  char amiga;
};

struct wav
{
  char riff[4];
  long overalllength;
  char wave[4];
  char fmt[4];
  long pad1;
  short pad2;
  short channels;
  long rate;
  long avbps;
  short pad3;
  short bitspersample;
  char data[4];
  long length;
};

FD_EventPrefsWindow *openeventprefs();
void selectevent(FD_EventPrefsWindow *,int);
void updateevent(FD_EventPrefsWindow *,int);
FD_EventPrefsWindow *eventprefscontrol(FD_EventPrefsWindow *,FL_OBJECT *);

#endif
