/* File Requester 0.1alpha
   (C) Dario Abatianni (eisfuchs@tigress.com)

   Start: 25-Okt-1999, 11:20 */

#include "../Forms/FileRequester.c"
#include "FileSelector.h"
#include "Constants.h"
#include <dirent.h>
#include <sys/stat.h>

void readpath(FD_RequestWindow *requester,char *dir)
{
  DIR *dirhandle;
  struct dirent *entry;
  struct stat status;
  char entryname[258],statusname[258],*path;

  path=requester->vdata;

  fl_set_object_color(requester->BusyLED,FL_RED,FL_RED);
  fl_clear_browser(requester->DirectoryList);

  strcpy(path,dir);

  fl_set_input(requester->Path,path);

  dirhandle=opendir(path);
  if(dirhandle==0) fl_add_browser_line(requester->DirectoryList,"Konnte Verzeichnis nicht ffnen!");
  else
  {
    while((entry=readdir(dirhandle))!=0)
    {
      if(strcmp(entry->d_name,".")!=0 && strcmp(entry->d_name,"..")!=0)
      {
        sprintf(statusname,"%s/%s",path,entry->d_name);
        lstat(statusname,&status);

        sprintf(entryname,"@C%d@n%s",(S_ISDIR(status.st_mode)) ? COL_DIR : COL_FILE,entry->d_name);
        fl_add_browser_line(requester->DirectoryList,entryname);
      }
    } // endwhile
    closedir(dirhandle);
  }
  sortbrowser(requester->DirectoryList);
  fl_set_object_color(requester->BusyLED,FL_MCOL,FL_MCOL);
}

void openfilerequester(struct filerequester *filerequester,char *title,char *path)
{
  FD_RequestWindow *requester;
  char *pathmem;

  requester=create_form_RequestWindow();
  fl_show_form(requester->RequestWindow,FL_PLACE_MOUSE,FL_TRANSIENT,title);

  pathmem=calloc(257,1);
  if(pathmem==0) logerror(errorlogwindow,"openfilerequester(): pathmem==0!");
  else
  {
    if(path[0]=='/') strcpy(pathmem,path);
    else
    {
      getcwd(pathmem,256);
      strcat(pathmem,"/");
      strcat(pathmem,path);
    }

    requester->vdata=pathmem;
    readpath(requester,pathmem);
  }

  filerequester->active=1;
  filerequester->okay=0;
  filerequester->window=requester;
}

void enterdir(FD_RequestWindow *requester,char *dir)
{
  strcat(requester->vdata,dir);
  strcat(requester->vdata,"/");
  readpath(requester,requester->vdata);
}

int requestercontrol(struct filerequester *requester,FL_OBJECT *select)
{
  int quit,line,count;
  char dirstring[6],name[LINELEN],file[LINELEN];

  sprintf(dirstring,"@C%d@n",COL_DIR);
  quit=0;

  if(select==requester->window->Root)
  {
    readpath(requester->window,"/");
  }

  if(select==requester->window->Parent)
  {
    strcpy(name,fl_get_input(requester->window->Path));

    count=strlen(name)-1;
    if(count>1)
    {
      while(name[--count]!='/' && count!=0);
      if(count==0) name[0]='/';
      name[count+1]=0;
      readpath(requester->window,name);
    }
  }

  if(select==requester->window->Path)
  {
    strcpy(name,fl_get_input(requester->window->Path));
    if(name[0]==0) strcpy(name,"/");
    if(name[strlen(name)-1]!='/') strcat(name,"/");
    readpath(requester->window,name);
  }

  if(select==requester->window->DirectoryList)
  {
    line=fl_get_browser(requester->window->DirectoryList);
    if(line>0)
    {
      strcpy(name,fl_get_browser_line(requester->window->DirectoryList,line));
      if(strncmp(dirstring,name,strlen(dirstring))==0)
      {
        enterdir(requester->window,name+strlen(dirstring));
      }
      else
      {
        strcpy(file,fl_get_input(requester->window->Name));
        if(strcmp(name+strlen(dirstring),file)==0) select=requester->window->Okay;
        else
        {
          fl_set_input(requester->window->Name,name+strlen(dirstring));   // Angenommen, da strlen(dirsting)==strlen(namestring)
        }
      }
    }
  }

  if(select==requester->window->Okay)
  {
    requester->okay=1;

    strcpy(requester->name,fl_get_input(requester->window->Name));
    strcpy(requester->path,fl_get_input(requester->window->Path));

    if(strlen(requester->path))
    {
      if(requester->path[strlen(requester->path)-1]!='/') strcat(requester->path,"/");
    }

    strcpy(requester->find,requester->path);
    strcat(requester->find,requester->name);
    
    quit=1;
  }

  if(select==requester->window->Cancel) quit=1;

  if(quit==0) return 1;
  else
  {
    free(requester->window->RequestWindow->u_vdata);
    fl_hide_form(requester->window->RequestWindow);
    requester->active=0;
    return 0;
  }
}
