/* Ignore.c
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Funktionen fr die Ignore-Funktion */

#include "Ignore.h"

void addignore(struct list *ignorelist,char *name,int query)
{
  struct node *newignorenode,*node;
  struct ignore *newignore;
  char *newname;

  if(ignorelist==0) logerror(errorlogwindow,"addignore(): ignorelist==0!");
  else
  {
    node=isignore(ignorelist,name,0);

    if(node) remignore(node);
    
    newignorenode=addnewnodetolist(ignorelist,sizeof(struct ignore));

    if(newignorenode==0) logerror(errorlogwindow,"addignore(): newignorenode==0!");
    else
    {
      newignore=newignorenode->data;
      newignore->query=query;

      newname=malloc(strlen(name)+1);  /* +1 wegen Ende mit 0! */

      if(newname==0) logerror(errorlogwindow,"addignore(): newname==0!");
      else
      {
        strcpy(newname,name);
        newignore->name=newname;
      }
    }
  }
}

struct node *remignore(struct node *ignorenode)
{
  struct node *returnnode;
  struct ignore *ignore;

  returnnode=0;

  if(ignore==0) logerror(errorlogwindow,"remignore(): ignore==0!");
  else
  {
    ignore=ignorenode->data;
    free(ignore->name);

    returnnode=freenode(ignorenode);
  }

  return returnnode;
}

/* Soll dieser Nick ignoriert werden? */
struct node *isignore(struct list *ignorelist,char *name,int query)
{
  struct node *lookignorenode,*doignore;
  struct ignore *lookignore;

  doignore=0;
  if(ignorelist)
  {
    lookignorenode=ignorelist->head;

    while(lookignorenode!=0 && doignore==0)
    {
      lookignore=lookignorenode->data;

      if(nickcmp(lookignore->name,name)==0)
      {
        if(query)
        {
          if(lookignore->query) doignore=lookignorenode;
        }
        else
        {
          doignore=lookignorenode;
        }
      }
      lookignorenode=lookignorenode->next;
    }
  }

  return doignore;
}

FD_IgnoreWindow *openignore()
{
  FD_IgnoreWindow *ignore;
  struct node *lookignorenode;
  struct ignore *lookignore;
  char nick[NICKLEN+7];

  ignore=create_form_IgnoreWindow();

  if(prefs.ignorelist)
  {
    lookignorenode=prefs.ignorelist->head;
    while(lookignorenode!=0)
    {
      lookignore=lookignorenode->data;

      sprintf(nick,"%s\t%s",lookignore->name,(lookignore->query==0) ? "" : "Query");
      fl_add_browser_line(ignore->IgnoreList,nick);
      lookignorenode=lookignorenode->next;
    } // endwhile
  }

  fl_set_input_return(ignore->NickInput,FL_RETURN_CHANGED);
  fl_set_input_maxchars(ignore->NickInput,9);
  fl_show_form(ignore->IgnoreWindow,FL_PLACE_POSITION,FL_TRANSIENT,"Ignorieren");

  return ignore;
}

FD_IgnoreWindow *ignorecontrol(FD_IgnoreWindow *ignore,FL_OBJECT *select)
{
  char nick[NICKLEN+7];
  int quit,count,helpcount,numsel;
  struct node *lookignorenode;
  struct ignore *lookignore;

  quit=0;

  if(select==ignore->NickInput)
  {
    count=fl_get_browser(ignore->IgnoreList);
    helpcount=count;

    if(count!=0)
    {
      lookignorenode=prefs.ignorelist->head;
      while(--count!=0) lookignorenode=lookignorenode->next;

      lookignore=lookignorenode->data;

      free(lookignore->name);
      strcpy(nick,fl_get_input(ignore->NickInput));

      lookignore->name=malloc(strlen(nick)+1);
      if(lookignore->name==0) logerror(errorlogwindow,"ignorecontrol(): lookignore->name==0!");
      else strcpy(lookignore->name,nick);

      sprintf(nick,"%s\t%s",lookignore->name,(lookignore->query==0) ? "" : "Query");
      fl_replace_browser_line(ignore->IgnoreList,helpcount,nick);
    }
  }

  if(select==ignore->Add)
  {
    strcpy(nick,"*Neu*");
    addignore(prefs.ignorelist,nick,0);
    fl_set_button(ignore->Query,0);
    fl_addto_browser(ignore->IgnoreList,nick);
    fl_set_input(ignore->NickInput,nick);
    fl_select_browser_line(ignore->IgnoreList,fl_get_browser_maxline(ignore->IgnoreList));
  }

  if(select==ignore->Up)
  {
    numsel=fl_get_browser(ignore->IgnoreList);
    if(numsel>1)
    {
      void *temp;

      swapbrowserline(ignore->IgnoreList,numsel,numsel-1);
      fl_select_browser_line(ignore->IgnoreList,numsel-1);

      lookignorenode=prefs.ignorelist->head;
      while(--numsel!=0) lookignorenode=lookignorenode->next;

      temp=lookignorenode->data;
      lookignorenode->data=lookignorenode->prev->data;
      lookignorenode->prev->data=temp;
    }
  }

  if(select==ignore->Down)
  {
    numsel=fl_get_browser(ignore->IgnoreList);
    if(numsel<fl_get_browser_maxline(ignore->IgnoreList))
    {
      void *temp;

      swapbrowserline(ignore->IgnoreList,numsel,numsel+1);
      fl_select_browser_line(ignore->IgnoreList,numsel+1);

      lookignorenode=prefs.ignorelist->head;
      while(--numsel!=0) lookignorenode=lookignorenode->next;

      temp=lookignorenode->data;
      lookignorenode->data=lookignorenode->next->data;
      lookignorenode->next->data=temp;
    }
  }

  if(select==ignore->Remove)
  {
    count=fl_get_browser(ignore->IgnoreList);
    helpcount=count;
    if(count!=0)
    {
      fl_delete_browser_line(ignore->IgnoreList,count);
      lookignorenode=prefs.ignorelist->head;
      while(--count!=0) lookignorenode=lookignorenode->next;

      remignore(lookignorenode);
      if(helpcount>fl_get_browser_maxline(ignore->IgnoreList)) helpcount--;
      fl_select_browser_line(ignore->IgnoreList,helpcount);
    }
  }

  if(select==ignore->IgnoreList)
  {
    count=fl_get_browser(ignore->IgnoreList);
    if(count!=0)
    {
      lookignorenode=getnodebynumber(prefs.ignorelist,count-1);
      lookignore=lookignorenode->data;

      fl_set_input(ignore->NickInput,lookignore->name);
      fl_set_button(ignore->Query,lookignore->query);
    }
  }

  if(select==ignore->Query)
  {
    count=fl_get_browser(ignore->IgnoreList);
    if(count!=0)
    {
      lookignorenode=getnodebynumber(prefs.ignorelist,count-1);
      lookignore=lookignorenode->data;

      lookignore->query=fl_get_button(ignore->Query);
      sprintf(nick,"%s\t%s",lookignore->name,(lookignore->query==0) ? "" : "Query");
      fl_replace_browser_line(ignore->IgnoreList,count,nick);
    }
  }

  if(select==ignore->Cancel) quit=1;

  if(select==ignore->Save)
  {
// parsen
    writeprefs(&prefs);
    quit=1;
  }

  if(quit==0) return ignore;
  else
  {
    fl_hide_form(ignore->IgnoreWindow);
    readprefs(&prefs);
    return 0;
  }
}
