/* ParseIn.c
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Funktion fr das Parsen der hereinkommenden Zeilen */

#include <stdlib.h>
#include <forms.h>

#include "ParseIn.h"
#include "Events.h"
#include "FoxIRC.h"
#include "Query.h"
#include "NickChange.h"
#include "Morse.h"
#include "Scripts.h"

extern struct preferences prefs;
extern struct channel *activechannel;
extern FD_IsOnWindow *isonwindow;
extern FD_ChannelListWindow *channellistwindow;
extern FD_MainWindow *mainform;
extern FD_NickchangeWindow *nickchangewindow;
extern char dns[],*version;
extern struct servernode *chosenserver;
extern struct timezone tz;
extern int nickwasopen;

void parsein(struct server *server,unsigned char *rawstring)
{
  struct channel *channel,*outchannel;
  struct node *node,*querynode;
  char sendnick[LINELEN],ctcp[LINELEN],nicklist[NICKLEN],outbuffer[LINELEN],*part[MAXPART],
       dccname[256],modenick[256],*modename;
  int count,incount,plus,bell,hilight,checktype;
  long dccport,dccsize;
  unsigned long dccip;

  outbuffer[0]=0;
  sendnick[0]=0;
  incount=0;
  outchannel=activechannel;
  querynode=0;
  bell=0;
  hilight=0;
  checktype=EVENT_NONE;

  outscript(&prefs,rawstring);
  outscript(&prefs,"\n");

  while(rawstring[incount]!=0)
  {
    if(rawstring[incount]==0x0a || rawstring[incount]==0x0d) rawstring[incount]=0;
    incount++;
  } // endwhile

  if(rawstring[0]==':')
  {
    count=1;
    while(rawstring[count]!='!' && count!=sizeof(sendnick) && rawstring[count]!=' ') sendnick[count-1]=rawstring[count++];
    sendnick[count-1]=0;

    if(strlen(server->ircname)==0)
    {
      count=1;
      while(rawstring[count]!=0 && rawstring[count]!=' ') server->ircname[count-1]=rawstring[count++];
      server->ircname[count-1]=0;
//      printf("Registered Server %s\n",server->ircname);
    }
  }

  count=0;
  while(rawstring[count]!=0)
  {
    if(rawstring[count]<32) printf("<%d>",rawstring[count]);
    else printf("%c",rawstring[count]);
    count++;
  } // endwhile
  printf("\n");

  if(strcasecmp(sendnick,server->ircname)==0) sprintf(outbuffer,"\\C%dServer:\t%s",COL_SERVER,rawstring+strlen(server->ircname)+2);
  else
  {
    count=1;
    while(rawstring[count]!=0 && rawstring[count]!=' ') outbuffer[count-1]=rawstring[count++];
    outbuffer[count-1]=0;
  }

  if(rawstring[0]==':') part[0]=rawstring+1; else part[0]=rawstring;

  for(count=1;count!=MAXPART;count++) part[count]=0;

  count=1;
  incount=1;

  while(rawstring[incount]!=0)
  {
    if(rawstring[incount]==' ')
    {
      rawstring[incount]=0;
      part[count]=rawstring+incount+1;
      if(part[count][0]==':')
      {
        part[count]++;
        incount=strlen(rawstring)-1;
      }
      count++;
    }
    incount++;
  } // endwhile

  if(strcasecmp(part[0],"PING")==0)
  {
    sprintf(outbuffer,"PONG %s",part[1]);
    transmitraw(server->sock,outbuffer);

    if(prefs.serverpings)
    {
      sprintf(outbuffer,"\\C%dPING\tPING-Anforderung von %s empfangen. Schicke PONG-Antwort.",COL_PRG,part[1]);
    }
    else outbuffer[0]=0;
  }

  if(strcasecmp(part[1],"MODE")==0)
  {
    checktype=EVENT_MODE;

    if(part[2][0]=='#' || part[2][0]=='&')    // Channel-Modes
    {
      outchannel=getchannelbyname(server,part[2]);
      plus=(part[3][0]=='+');

      count=0;
      incount=1;

      while(part[3][incount]!=' ' && part[3][incount]!=0)
      {
        modenick[0]=0;
        if(part[4])
        {
          int copycount;

          copycount=0;

          while(part[4][count]!=' ' && part[4][count]!=0) modenick[copycount++]=part[4][count++];
          modenick[copycount]=0;
        }
        count++;

        switch(part[3][incount])
        {
          case 'o':
            sprintf(outbuffer,"\\C%dModus\t%s ",COL_PRG,(strcasecmp(sendnick,server->currentnick)==0) ? "Du" : sendnick);
            if(plus==0) strcat(outbuffer,(strcasecmp(sendnick,server->currentnick)==0) ? "entziehst " : "entzieht ");
            else strcat(outbuffer,(strcasecmp(sendnick,server->currentnick)==0) ? "verleihst " : "verleiht ");
            if(strcasecmp(modenick,server->currentnick)==0) strcat(outbuffer,"dir"); else strcat(outbuffer,modenick);
            strcat(outbuffer," den Operator-Status.");
            opnick(outchannel,modenick,((plus) ? 1 : 0));
          break;

          case 'v':
            sprintf(outbuffer,"\\C%dModus\t%s ",COL_PRG,(strcasecmp(sendnick,server->currentnick)==0) ? "Du" : sendnick);
            if(plus==0) strcat(outbuffer,(strcasecmp(sendnick,server->currentnick)==0) ? "entziehst " : "entzieht ");
            else strcat(outbuffer,(strcasecmp(sendnick,server->currentnick)==0) ? "gibst " : "gibt ");
            if(strcasecmp(modenick,server->currentnick)==0) strcat(outbuffer,"dir"); else strcat(outbuffer,modenick);
            if(plus==0) strcat(outbuffer," die");
            strcat(outbuffer," Redefreiheit.");
            voicenick(outchannel,modenick,((plus) ? 1 : 0));
          break;

          case 'b':
            sprintf(outbuffer,"\\C%dModus\t%s ",COL_PRG,(strcasecmp(sendnick,server->currentnick)==0) ? "Du" : sendnick);
            if(plus==0) strcat(outbuffer,(strcasecmp(sendnick,server->currentnick)==0) ? "hebst" : "hebt");
            else strcat(outbuffer,(strcasecmp(sendnick,server->currentnick)==0) ? "verhngst" : "verhngt");
            if(plus==0) strcat(outbuffer," den Bann gegen "); else strcat(outbuffer," einen Bann ber ");
            if(strncasecmp(modenick,server->currentnick,strlen(server->currentnick))==0 && modenick[strlen(server->currentnick)]=='!') strcat(outbuffer,"dich"); else strcat(outbuffer,modenick);
            if(plus==0) strcat(outbuffer," auf."); else strcat(outbuffer,".");
            if(outchannel->banwin)
            {
              if(plus) addban(outchannel,modenick);
              else removeban(outchannel,modenick);
            }
          break;

          case 'e':
            sprintf(outbuffer,"\\C%dModus\t%s ",COL_PRG,(strcasecmp(sendnick,server->currentnick)==0) ? "Du" : sendnick);
            if(plus==0) strcat(outbuffer,(strcasecmp(sendnick,server->currentnick)==0) ? "hebst" : "hebt");
            else strcat(outbuffer,"setzt");
            if(plus==0) strcat(outbuffer," die Bannausnahme gegen "); else strcat(outbuffer," eine Bannausnahme auf ");
            if(strncasecmp(modenick,server->currentnick,strlen(server->currentnick))==0 && modenick[strlen(server->currentnick)]=='!') strcat(outbuffer,"dich"); else strcat(outbuffer,modenick);
            if(plus==0) strcat(outbuffer," auf."); else strcat(outbuffer,".");
            if(outchannel->banwin)
            {
              if(plus) addexception(outchannel,modenick);
              else removeexception(outchannel,modenick);
            }
          break;

          case 'i':
            if(strcasecmp(sendnick,server->currentnick)==0) sprintf(outbuffer,"\\C%dModus\tDu",COL_PRG);
            else sprintf(outbuffer,"\\C%dModus\t%s",COL_PRG,sendnick);
            strcat(outbuffer," setzt den Kanalmodus auf '");
            strcat(outbuffer,(plus==0) ? "auch ohne Einladung'." : "nur mit Einladung'.");
            setchannelmode(outchannel->window,'i',plus);
          break;

          case 'k':
            if(strcasecmp(sendnick,server->currentnick)==0) sprintf(outbuffer,"\\C%dModus\tDu",COL_PRG);
            else sprintf(outbuffer,"\\C%dModus\t%s",COL_PRG,sendnick);
            if(plus)
            {
              strcat(outbuffer," setzt das Kanalkennwort auf ");
              strcat(outbuffer,modenick);
              strcat(outbuffer,".");
              displaychannelframe(outchannel,1);
            }
            else
            {
              strcat(outbuffer," lscht das Kanalkennwort.");
              displaychannelframe(outchannel,0);
            }
            setchannelmode(outchannel->window,'k',plus);
          break;

          case 'l':
            if(strcasecmp(sendnick,server->currentnick)==0)
            {
              sprintf(outbuffer,"\\C%dModus\tDu ",COL_PRG);
              if(plus==0) strcat(outbuffer,"hebst das Nicklimit fr diesen Kanal auf.");
              else
              {
                strcat(outbuffer,"setzt das Nicklimit fr diesen Kanal auf ");
                strcat(outbuffer,part[4]);
                strcat(outbuffer,".");
              }
            }
            else
            {
              sprintf(outbuffer,"\\C%dModus\t%s ",COL_PRG,sendnick);
              if(plus==0) strcat(outbuffer,"hebt das Nicklimit fr diesen Kanal auf.");
              else
              {
                strcat(outbuffer,"setzt das Nicklimit fr diesen Kanal auf ");
                strcat(outbuffer,part[4]);
                strcat(outbuffer,".");
              }
            }
            setchannelmode(outchannel->window,'l',plus);
            setchannellimit(outchannel->window,part[4]);
          break;

          case 'a':
            sprintf(outbuffer,"\\C%dModus\t%s setzt den Kanalmodus auf '",COL_PRG,(strcasecmp(sendnick,server->currentnick)==0) ? "Du" : sendnick);
            strcat(outbuffer,(plus==0)?"'nicht anonym'.":"'anonym'.");
//            setchannelmode(outchannel->window,'a',plus);        // noch gibt es dafr keine Anzeige
          break;

          case 'm':
            sprintf(outbuffer,"\\C%dModus\t%s setzt den Kanalmodus auf '",COL_PRG,(strcasecmp(sendnick,server->currentnick)==0) ? "Du" : sendnick);
            strcat(outbuffer,(plus==0)?"nicht moderiert'.":"moderiert'.");
            setchannelmode(outchannel->window,'m',plus);
          break;

          case 'n':
            sprintf(outbuffer,"\\C%dModus\t%s setzt den Kanalmodus auf '",COL_PRG,(strcasecmp(sendnick,server->currentnick)==0) ? "Du" : sendnick);
            strcat(outbuffer,(plus==0)?"auch Nachrichten von Auerhalb'.":"keine Nachrichten von Auerhalb'.");
            setchannelmode(outchannel->window,'n',plus);
          break;

          case 'p':
            sprintf(outbuffer,"\\C%dModus\t%s setzt den Kanalmodus auf '",COL_PRG,(strcasecmp(sendnick,server->currentnick)==0) ? "Du" : sendnick);
            strcat(outbuffer,(plus==0)?"ffentlich'.":"privat'.");
            setchannelmode(outchannel->window,'p',plus);
          break;

          case 's':
            sprintf(outbuffer,"\\C%dModus\t%s setzt den Kanalmodus auf '",COL_PRG,(strcasecmp(sendnick,server->currentnick)==0) ? "Du" : sendnick);
            strcat(outbuffer,(plus==0)?"sichtbar'.":"geheim'.");
            setchannelmode(outchannel->window,'s',plus);
          break;

          case 't':
            sprintf(outbuffer,"\\C%dModus\t%s setzt den Kanalmodus auf '",COL_PRG,(strcasecmp(sendnick,server->currentnick)==0) ? "Du" : sendnick);
            strcat(outbuffer,(plus==0)?"kein Themenschutz'.":"Themaschutz'.");
            setchannelmode(outchannel->window,'t',plus);
          break;
        } // endswitch

        if(strlen(outbuffer)>0) displayirc(outbuffer,outchannel);
        outbuffer[0]=0;

        incount++;
        while(part[3][incount]=='+' || part[3][incount]=='-') plus=(part[3][incount++]=='+');   // bei +-b (?)
      } // endwhile
    }
    else                        // User-Modes
    {
      switch(part[3][1])
      {
        case 'i':
          if(strcasecmp(sendnick,server->currentnick)==0) sprintf(outbuffer,"\\C%dModus\tDu machst ",COL_PRG);
          else sprintf(outbuffer,"\\C%dModus\t%s macht ",COL_PRG,sendnick);
          if(strcasecmp(part[2],server->currentnick)==0) strcat(outbuffer,"dich"); else strcat(outbuffer,part[2]);
          if(part[3][0]=='-') strcat(outbuffer," sichtbar."); else strcat(outbuffer," unsichtbar.");
        break;
      } // endswitch
    }
  }

  if(strcasecmp(part[1],"PRIVMSG")==0)
  {
    bell=1;

    if(part[2][0]=='#' || part[2][0]=='&')
    {
      char hilightstr[256];
      int hicount;

      hicount=0;
      
      if(prefs.hilight && strlen(prefs.hilightstring))
      {
        for(count=0;count<strlen(prefs.hilightstring)+1;count++)
        {
          if(prefs.hilightstring[count]==' ' || prefs.hilightstring[count]==0)
          {
            hilightstr[hicount]=0;      // berflssig?

            if(strcasestr(part[3],hilightstr)!=0) hilight=1;

            hicount=0;
          }
          else
          {
            hilightstr[hicount++]=prefs.hilightstring[count];
            hilightstr[hicount]=0;
          }
        } // endfor
      }

      outchannel=getchannelbyname(server,part[2]);

      if(part[3][0]==1)    // Channelaction
      {
        count=1;
        while(part[3][count]!=1 && part[3][count]!=0) ctcp[count-1]=part[3][count++];
        ctcp[count-1]=0;
        ctcp[count]=0;     // Workaround

        if(strncasecmp(ctcp,"ACTION",6)==0)
        {
          sprintf(outbuffer,"\\C%d\t* %s %s",(hilight) ? COL_HILIGHT : COL_ACTION,sendnick,part[3]+8);
          checktype=EVENT_TEXT;
        }
        else if(strncasecmp(ctcp,"PING",4)==0) sprintf(outbuffer,"\\C%dCTCP\tCTCP-PING von %s an Kanal %s empfangen.",COL_CTCP,sendnick,activechannel->name);
        else sprintf(outbuffer,"\\C%dCTCP\tUnbekannte CTCP-%s Anforderung von %s an Kanal %s empfangen.",COL_CTCP,ctcp,sendnick,activechannel->name);
      }
      else                 // normale Channelmessage
      {
        sprintf(outbuffer,"\\C%d%s%s:\t%s",(hilight) ? COL_HILIGHT : COL_TEXT,(sendnick[0]=='\\') ? "\\" : "",sendnick,part[3]);
        checktype=EVENT_TEXT;
      }
    }
    else
    {
      if(part[3][0]==1)
      {
        count=1;
        while(part[3][count]!=1 && part[3][count]!=0) ctcp[count-1]=part[3][count++];
        ctcp[count-1]=0;
        ctcp[count]=0;    // Workaround

        if(strcasecmp(ctcp,"VERSION")==0)
        {
          sprintf(outbuffer,"NOTICE %s :%cVERSION %s%c",sendnick,1,version,1);
          transmitraw(server->sock,outbuffer);
        }

        if(strcasecmp(ctcp,"FINGER")==0)
        {
          sprintf(outbuffer,"NOTICE %s :%cFINGER %s%c",sendnick,1,"Keep your paws to yourself, okay?",1);
          transmitraw(server->sock,outbuffer);
        }

        if(strncasecmp(ctcp,"PING",4)==0)
        {
          char *pingnum;
          pingnum=malloc(strlen(ctcp+5)+1);
          if(pingnum==0) logerror(errorlogwindow,"parsein(): pingnum==0!");
          else
          {
            strcpy(pingnum,ctcp+5);

            sprintf(outbuffer,"NOTICE %s :%cPING %s%c",sendnick,1,pingnum,1);
            transmitraw(server->sock,outbuffer);
            free(pingnum);
          }
        }
        sprintf(outbuffer,"\\C%dCTCP\tCTCP-%s von %s empfangen.",COL_CTCP,ctcp,sendnick);

        if(strncasecmp(ctcp,"ZIRCON DRAW",11)==0)
        {
          if(prefs.sketchpad==0) outbuffer[0]=0;
          else
          {
            sprintf(outbuffer,"\\C%dCTCP\tZircon-Sketchpad von %s: %s",COL_CTCP,sendnick,part[3]+8);
          }
        }

        if(strncasecmp(ctcp,"DCC SEND ",9)==0)
        {
          count=9;
          while(ctcp[count]!=' ' && ctcp[count]!=0) dccname[count-9]=ctcp[count++];
          dccname[count-9]=0;

          incount=++count;
          while(ctcp[count]!=' ' && ctcp[count]!=0) count++;
          ctcp[count]=0;
          dccip=atof(ctcp+incount);
          // printf("%s %d\n",ctcp+incount,dccip);
          incount=++count;
          while(ctcp[count]!=' ' && ctcp[count]!=0) count++;
          ctcp[count]=0;
          dccport=atoi(ctcp+incount);

          incount=++count;
          while(ctcp[count]!=' ' && ctcp[count]!=0) count++;
          ctcp[count]=0;
          dccsize=atoi(ctcp+incount);

          dccgetadd(sendnick,dccname,sendnick,dccip,dccport,dccsize);
          outbuffer[0]=0;                                           // Um keine /CTCP-Meldung zu erhalten
        }

        if(strncasecmp(ctcp,"ACTION",6)==0)                         // Query-Action
        {
          part[3][strlen(part[3])-1]=0;         /* angehngtes <1> Byte entfernen */

          querynode=getquerybyname(server,sendnick);
          if(querynode)
          {
            addquerynick(sendnick);
            sprintf(outbuffer,"\\C%d\t* %s %s",COL_QUERY,sendnick,part[3]+8);
          }
          else
            sprintf(outbuffer,"\\C%d*%s*\t* %s %s",COL_QUERY,sendnick,sendnick,part[3]+8);

          strcpy(server->lastquery,sendnick);

          checktype=EVENT_QUERY;
        }
      }
      else
      {
        sprintf(outbuffer,"\\C%d*%s*\t%s",COL_QUERY,sendnick,part[3]);
        strcpy(server->lastquery,sendnick);
        querynode=getquerybyname(server,sendnick);
        if(querynode) addquerynick(sendnick);
        checktype=EVENT_QUERY;
      }
    }
  }

  if(strcasecmp(part[0],"NOTICE")==0)  /* Server-Notiz */
  {
    bell=1;

    sprintf(outbuffer,"\\C%dServernotiz:\t%s",COL_SERVER,part[2]);
  }

  if(strcasecmp(part[1],"NOTICE")==0)  /* Client-Notiz */
  {
    bell=1;

    if(part[3][0]==1)
    {
      count=1;
      while(part[3][count]!=1 && part[3][count]!=0) ctcp[count-1]=part[3][count++];
      ctcp[count-1]=0;
      ctcp[count]=0;    // Workaround

      sprintf(outbuffer,"\\C%dCTCP\tAntwort von %s: %s",COL_CTCP,sendnick,ctcp);
    }
    else
    {
      /* Oder doch der Server? */
      if(strcmp(sendnick,server->ircname)==0) sprintf(outbuffer,"\\C%dServernotiz\t%s",COL_SERVER,part[3]);
      else sprintf(outbuffer,"\\C%dNotiz\t%s: %s",COL_QUERY,sendnick,part[3]);
    }
  }

  if(strcasecmp(part[1],"INVITE")==0)
  {
    bell=1;
    checktype=EVENT_INVITE;

    if(prefs.joinoninvite)  // Autojoin bei Einladung?
    {
      sprintf(outbuffer,"JOIN %s",part[3]);
      transmitraw(server->sock,outbuffer);
      outbuffer[0]=0;
    }
    sprintf(outbuffer,"\\C%dEinladung\t%s hat dich in den Kanal %s eingeladen.",COL_PRG,sendnick,part[3]);
  }

  if(strcasecmp(part[1],"JOIN")==0)
  {
    bell=1;
    checktype=EVENT_JOIN;

    outchannel=getchannelbyname(server,part[2]);
    if(strcmp(server->currentnick,sendnick)==0)
    {
      channel=addchannel(server,part[2]);
      if(chosenserver->password) strcpy(channel->password,chosenserver->password);

      if(channel!=0)
      {
        outchannel=channel;
        activechannel=channel;

        sprintf(outbuffer,"MODE %s",activechannel->name);
        transmitraw(server->sock,outbuffer);

        displaytopic(activechannel->window,"");
        displaychannelframe(activechannel,0);

        sprintf(outbuffer,"\\C%dJoin\tDu hast den Kanal %s betreten. (%s)",COL_PRG,activechannel->name,part[0]);
      }
    }
    else
    {
      sprintf(outbuffer,"\\C%dJoin\t%s hat diesen Kanal betreten. (%s)",COL_PRG,sendnick,part[0]);
      addnick(outchannel,sendnick);
    }
  }

  if(strcasecmp(part[1],"PART")==0)
  {
    bell=1;
    checktype=EVENT_PART;

    outchannel=getchannelbyname(server,part[2]);
    if(strcmp(server->currentnick,sendnick)==0)
    {
      sprintf(outbuffer,"\\C%dPart\tDu hast den Kanal %s verlassen. (%s)",COL_PRG,part[2],part[3]);
      displayirc(outbuffer,outchannel);
      outbuffer[0]=0;

      resetwindow(activechannel);
      activechannel=removechannel(server,activechannel);
    }
    else
    {
/*
      if(strcasecmp(part[2],activechannel->name)==0) sprintf(outbuffer,"\\C%dPart\t%s hat diesen Kanal verlassen. (%s)",COL_PRG,sendnick,part[3]);
      else sprintf(outbuffer,"\\C%dPart\t%s hat den Kanal %s verlassen. (%s)",COL_PRG,sendnick,part[2],part[3]);
*/
      sprintf(outbuffer,"\\C%dPart\t%s hat diesen Kanal verlassen. (%s)",COL_PRG,sendnick,part[3]);
      removenick(outchannel,sendnick);
    }
  }

  if(strcasecmp(part[1],"QUIT")==0)
  {
    bell=1;
    checktype=EVENT_PART;

    quitnick(server,sendnick,part[2]);    // Ausgabe erfolgt in dieser Funktion
    outbuffer[0]=0;
  }

  if(strcasecmp(part[1],"KICK")==0)
  {
    bell=1;

    outchannel=getchannelbyname(server,part[2]);

    if(strcasecmp(part[3],server->currentnick)==0)
    {
      sprintf(outbuffer,"\\C%dKick\t%s hat dich aus dem Kanal geworfen. (%s)",COL_PRG,sendnick,part[4]);
      displayirc(outbuffer,outchannel);
      outbuffer[0]=0;

      resetwindow(activechannel);
      activechannel=removechannel(server,activechannel);
      outchannel=0;
    }
    else if(strcasecmp(sendnick,server->currentnick)==0) sprintf(outbuffer,"\\C%dKick\tDu hast %s aus dem Kanal geworfen. (%s)",COL_PRG,part[3],part[4]);
    else sprintf(outbuffer,"\\C%dKick\t%s hat %s aus dem Kanal geworfen. (%s)",COL_PRG,sendnick,part[3],part[4]);

    if(outchannel) removenick(outchannel,part[3]); // Nickname nur entfernen, wenn man es nicht selber war
  }

  if(strcasecmp(part[1],"NICK")==0)
  {
    bell=1;

    if(strcmp(sendnick,server->currentnick)==0) setnick(server,part[2]);
    else
    {
      replacenick(server,sendnick,part[2]);
      checktype=EVENT_NICK;
    }

    outbuffer[0]=0;
  }

  if(strcmp(part[1],"301")==0)  // RPL_WAWAY
  {
    sprintf(outbuffer,"\\C%dAbwesend\t%s ist abwesend (%s)",COL_PRG,part[3],part[4]);
  }

  if(strcmp(part[1],"305")==0)  // RPL_UNWAWAY
  {
    sprintf(outbuffer,"\\C%dAnwesend\tDu bist wieder als anwesend eingetragen.",COL_PRG);
  }

  if(strcmp(part[1],"306")==0)  // RPL_NOWAWAY
  {
    sprintf(outbuffer,"\\C%dAbwesend\tDu bist nun als abwesend eingetragen.",COL_PRG);
  }

  if(strcmp(part[1],"311")==0)  // RPL_WHOISUSER
  {
    sprintf(outbuffer,"%s@%s",part[4],part[5]);
    addhostmasktonick(outchannel,part[3],outbuffer);

    sprintf(outbuffer,"\\C%dWhoIs\t%s ist %s@%s (%s)",COL_SERVER,part[3],part[4],part[5],part[7]);
  }

  if(strcmp(part[1],"312")==0)  // RPL_WHOISSERVER
  {
    sprintf(outbuffer,"\\C%dWhoIs\t- auf Server %s (%s)",COL_SERVER,part[4],part[5]);
  }

  if(strcmp(part[1],"313")==0)  // RPL_WHOISOPERATOR
  {
    sprintf(outbuffer,"\\C%dWhoIs\t- ist ein IRC-Operator",COL_SERVER);
  }

  if(strcmp(part[1],"317")==0)  // RPL_WHOISIDLE
  {
    sprintf(outbuffer,"\\C%dWhoIs\t- still seit %s Sekunden",COL_SERVER,part[4]);
  }

  if(strcmp(part[1],"318")==0)  // RPL_ENDOFWHOIS
  {
    sprintf(outbuffer,"\\C%dWhoIs\tEnde der WhoIs-Liste",COL_SERVER);
  }

  if(strcmp(part[1],"319")==0)  // RPL_WHOISCHANNELS
  {
    sprintf(outbuffer,"\\C%dWhoIs\t- ist in den Kanlen %s",COL_SERVER,part[4]);
  }

  if(strcmp(part[1],"331")==0)  // RPL_NO_TOPIC
  {
    displaytopic(activechannel->window,"");
    sprintf(outbuffer,"\\C%dThema\tKein Kanalthema gesetzt.",COL_PRG);
  }

  if(strcmp(part[1],"332")==0)  // RPL_TOPIC
  {
    displaytopic(activechannel->window,part[4]);
    if(channel->topiclist==0 && strlen(part[4])) addtopic(part[4],"<unbekannt>",channel);
    sprintf(outbuffer,"\\C%dThema\tDas Kanalthema ist: \"%s\".",COL_PRG,part[4]);
  }

  if(strcmp(part[1],"333")==0)  // RPL_WHO_TOPIC
  {
    time_t timestamp;
    timestamp=atoi(part[5]);
    sprintf(outbuffer,"\\C%dThema\tGesetzt von %s, am %s.",COL_PRG,part[4],ctime(&timestamp));
  }

  if(strcasecmp(part[1],"TOPIC")==0)
  {
    bell=1;

    outchannel=getchannelbyname(server,part[2]);

    displaytopic(outchannel->window,part[3]);
    sprintf(outbuffer,"\\C%dThema\t",COL_PRG);
    if(strcasecmp(sendnick,server->currentnick)==0) strcat(outbuffer,"Du"); else strcat(outbuffer,sendnick);
    strcat(outbuffer," setzt das Kanalthema auf \"");
    strcat(outbuffer,part[3]);
    strcat(outbuffer,"\".");
    addtopic(part[3],sendnick,outchannel);               // activechannel kann hier 0 sein!
  }

  if(strcmp(part[1],"324")==0)  // RPL_CHANNELMODEIS
  {
    outchannel=getchannelbyname(server,part[3]);
    outbuffer[0]=0;
    if(part[4][0]=='+')
    {
      int param=5;                /* Welcher Parameter (part[]) ist als nchstes dran? */
      count=1;

      if(part[4][count]!=0) sprintf(outbuffer,"\\C%dModus\tKanalmodi: ",COL_PRG);
      while(part[4][count]!=0)
      {
        switch(part[4][count])
        {
          case 'i':
            modename="nur mit Einladung";
          break;
          case 'k':
            modename="kennwortgeschtzt";
            strcpy(outchannel->password,part[param++]);  /* Nchsten Parameter vorbereiten */
          break;
          case 'l':
            strcat(outbuffer,"begrenzt auf ");
            strcat(outbuffer,part[param]);
            modename=" Nicks";
            setchannellimit(activechannel->window,part[param++]);  /* Nchsten Parameter vorbereiten */
          break;
          case 'm':
            modename="moderiert";
          break;
          case 'n':
            modename="keine Nachrichten von Auerhalb";
          break;
          case 'p':
            modename="privat";
          break;
          case 's':
            modename="geheim";
          break;
          case 't':
            modename="Themaschutz";
          break;
          default:
            strncat(outbuffer,part[4]+count,1);
            modename="";
          break;
        } // endswitch

        setchannelmode(activechannel->window,part[4][count],1);

        strcat(outbuffer,modename);
        strcat(outbuffer,(part[4][++count]!=0) ? ", " : "."); /* Kein ", " nach letztem Modus */
      } // endwhile
    }
  }

  if(strcmp(part[1],"329")==0)  // RPL_CHANNELCREATIONTIME
  {
    sprintf(outbuffer,"\\C%dTime\tDieser Kanal wurde zum Zeitpunkt %s erstellt.",COL_SERVER,part[4]);
  }

  if(strcmp(part[1],"303")==0)   // ISON_REPLY
  {
    server->isonreply=1;

    server->lag=server->isontime.tv_sec*1000000+server->isontime.tv_usec;
    gettimeofday(&server->isontime,&tz);
//    printf("Time %u\n",server->isontime.tv_sec);
    server->lag=server->isontime.tv_sec*1000000+server->isontime.tv_usec-server->lag;
    sprintf(outbuffer,"Lag: %3.2f",server->lag/1000000.0);
    updatelag(outbuffer);

//    printf("%d %d\n",fl_winget(),mainform->MainWindow->window);

    if(part[3]!=0)
    {
      if(prefs.autonotify==1 && isonwindow==0 && nickwasopen==0)
      {
        Window oldwindow;

        oldwindow=fl_winget();

        isonwindow=openison();

        fl_winfocus(oldwindow);
      }

      if(isonwindow!=0)
      {
        fl_clear_browser(isonwindow->IsOnList);
        line2browser(part[3],isonwindow->IsOnList);
      }

      checktype=EVENT_ISON;
    }
    outbuffer[0]=0;
  }

  if(strcmp(part[1],"322")==0 || strcmp(part[1],"323")==0)     // RPL_LIST
  {
    if(channellistwindow==0) channellistwindow=openchannellist();

    if(strcmp(part[1],"322")==0)
    {
      fl_add_browser_line(channellistwindow->ChannelList,part[3]);
      fl_add_browser_line(channellistwindow->NumofList,part[4]);
      fl_add_browser_line(channellistwindow->TopicList,part[5]);
    }
    outbuffer[0]=0;
  }

  if(strcmp(part[1],"341")==0)     // INVITE
  {
    outchannel=getchannelbyname(server,part[2]);
    sprintf(outbuffer,"\\C%dEinladung\tDu hast %s in den Kanal %s eingeladen.",COL_PRG,part[3],part[4]);
  }

  if(strcmp(part[1],"443")==0)     // INVITE
  {
    sprintf(outbuffer,"\\C%dEinladung\t%s ist bereits im Kanal %s.",COL_PRG,part[3],part[4]);
  }

  if(strcmp(part[1],"473")==0)     // +i
  {
    sprintf(outbuffer,"\\C%dInfo\tKann den Kanal %s nicht ohne Einladung betreten.",COL_PRG,part[3]);
  }

  if(strcmp(part[1],"475")==0)     // +k
  {
    sprintf(outbuffer,"\\C%dInfo\tKann den Kanal %s nicht ohne das richtige Kennwort betreten.",COL_PRG,part[3]);
  }

  if(strcmp(part[1],"401")==0)     // NO_SUCH_NICK
  {
    sprintf(outbuffer,"\\C%dFehler\tUnbekannter Nick/Kanal: %s.",COL_PRG,part[3]);
  }

  if(strcmp(part[1],"353")==0)     // NAMES_LIST
  {
    outchannel=getchannelbyname(server,part[4]);

    if(outchannel!=0)
    {
      clearnicklist(outchannel);

      count=0;
      fl_freeze_form(activechannel->window->MainWindow);

      do
      {
        nicklist[0]=0;
        incount=0;

        while(part[5][count]!=' ' && part[5][count]!=0) nicklist[incount++]=part[5][count++];
        nicklist[incount]=0;

        if(strlen(nicklist)>0)
        {
          addnick(outchannel,nicklist);

          if(nicklist[0]=='@' && strcasecmp(nicklist+1,server->currentnick)==0) opnick(outchannel,outchannel->server->currentnick,1);
          if(nicklist[0]=='+' && strcasecmp(nicklist+1,server->currentnick)==0) voicenick(outchannel,outchannel->server->currentnick,1);
        }
      } while(part[5][count++]!=0);

      fl_unfreeze_form(activechannel->window->MainWindow);
    }
    if(part[4][0]=='*') sprintf(outbuffer,"\\C%dNickliste\tOhne Kanal: %s",COL_SERVER,part[5]);
    else sprintf(outbuffer,"\\C%dNickliste\t%sKanal %s: %s",COL_SERVER,(part[4][0]=='&') ? "Lokaler " : "",part[4],part[5]);
 
    outchannel=activechannel;
  }

  if(strcmp(part[1],"366")==0)     // END_OF_NAMES_LIST
  {
    sprintf(outbuffer,"\\C%dInfo\tEnde der Nickliste.",COL_PRG);
  }

  if(strcmp(part[1],"367")==0)     // RPL_BANLIST
  {
    outchannel=getchannelbyname(server,part[3]);
    if(outchannel==0) printf("parsein(): Could not get channel structure for %s in banlist!\n",part[3]);
    else
    {
      if(outchannel->banwin)
      {
        addban(outchannel,part[4]);
        outbuffer[0]=0;
      }
      else
      {
        sprintf(outbuffer,"\\C%dBannliste\t%s ist im Kanal %s gebannt.",COL_SERVER,part[4],part[3]);
      }
    }
  }

  if(strcmp(part[1],"348")==0)     // RPL_BANLIST
  {
    outchannel=getchannelbyname(server,part[3]);
    if(outchannel==0) printf("parsein(): Could not get channel structure for %s in exceptionlist!\n",part[3]);
    else
    {
      if(outchannel->banwin)
      {
        addexception(outchannel,part[4]);
        outbuffer[0]=0;
      }
      else
      {
        sprintf(outbuffer,"\\C%dAusnahmeliste\t%s gilt im Kanal %s als Bannausnahme.",COL_SERVER,part[4],part[3]);
      }
    }
  }

  if(strcmp(part[1],"368")==0)     // END_OF_BAN_LIST
  {
    if(activechannel->banwin==0) sprintf(outbuffer,"\\C%dInfo\tEnde der Bannliste.",COL_PRG);
    else outbuffer[0]=0;
  }

  if(strcmp(part[1],"349")==0)     // END_OF_EXCEPTION_LIST
  {
    if(activechannel->banwin==0) sprintf(outbuffer,"\\C%dInfo\tEnde der Ausnahmeliste.",COL_PRG);
    else outbuffer[0]=0;
  }

  if(strcmp(part[1],"375")==0 || strcmp(part[1],"372")==0 || strcmp(part[1],"376")==0)  // MOTD
  {
    outbuffer[0]=0;
    if(prefs.motd==1)
    {
      if(strcmp(part[1],"376")==0) info("\\-",0);
      else sprintf(outbuffer,"\\C%d%sMOTD\t%s",COL_SERVER,(prefs.fixedmotd==1) ? "\\f" : "",part[3]);
    }
  }

  if(strcmp(part[1],"433")==0)   // NICK_IN_USE
  {
    if(++prefs.nicknum==MAXNICKNUM)
    {
      prefs.nicknum=0;
      if(nickchangewindow==0) nickchangewindow=opennickchange((activechannel==0) ? mainform : activechannel->window,prefs.nick[0]);
    }
    else
    {
      sprintf(outbuffer,"NICK %s",prefs.nick[prefs.nicknum]);
      transmitraw(server->sock,outbuffer);
      sprintf(outbuffer,"\\C%dNick\tNickname wird bereits benutzt. Versuche es mit %s.",COL_PRG,prefs.nick[prefs.nicknum]);
    }
  }

  if(strcmp(part[1],"001")==0 || strcmp(part[1],"002")==0 || strcmp(part[1],"003")==0)
  {
    server->cleartojoin=1;
    setnick(server,part[2]);  /* Falls vor dem Einloggen der Nickname neu gesetzt werden mute */
    prefs.nicknum=0;          /* Nickzhler zurcksetzen */
    sprintf(outbuffer,"\\C%dWillkommen\t%s",COL_SERVER,part[3]);
  }
  if(strcmp(part[1],"004")==0) sprintf(outbuffer,"\\C%dWillkommen\t%s %s %s %s",COL_SERVER,part[3],part[4],part[5],part[6]);

  /* WHOIS Reply */
  if(strcmp(part[1],"311")==0 || strcmp(part[1],"312")==0 || strcmp(part[1],"313")==0 ||
     strcmp(part[1],"317")==0 || strcmp(part[1],"318")==0 || strcmp(part[1],"319")==0)
  {
    if(strlen(dns))           /* Ist dies eine DNS-Anfrage? */
    {
      outbuffer[0]=0;         /* Alle WHOIS-Meldungen unterdrcken */

      if(strcasecmp(dns,part[3])==0 && strcmp(part[1],"311")==0)
      {
        unsigned char ipstr[4];

        getip(part[5],ipstr);
        sprintf(outbuffer,"\\C%dDNS\tDie IP-Adresse von %s lautet %d.%d.%d.%d",COL_PRG,part[3],ipstr[0],ipstr[1],ipstr[2],ipstr[3]);
      }
      if(strcmp(part[1],"318")==0) dns[0]=0;
    }
    querynode=isquery(server,part[2]);
  }
  
  if(strncasecmp(part[0],"ERROR",5)==0)
  {
    sprintf(outbuffer,"\\C%dFehler\t%s.",COL_PRG,part[1]);
    if(strncasecmp(part[1],"Closing Link:",13)==0)
    {
      count=strlen(part[1]);
      while(count!=0 && part[1][count]!='(') count--;

      sprintf(outbuffer,"\\C%dInfo\tVerbindung mit dem Server beendet. %s",COL_PRG,part[1]+count);
      displayirc(outbuffer,0);
      outbuffer[0]=0;

      cleanupserver(server);
    }
  }

  if(strlen(outbuffer)>0)
  {
    if(sendnick[0]) getnickhostmask(outchannel,part[0]); /* extrahiert hostmask aus der Servermeldung PRIVMSG */

    if(querynode==0)
    {
      if(isignore(prefs.ignorelist,sendnick,0)==0) displayirc(outbuffer,outchannel);
    }
    else
    {
      if(isignore(prefs.ignorelist,sendnick,1)==0)
      {
        struct query *query=querynode->data;
        displayquery(query,outbuffer,part[0]);
      }
    }
  }

  if(prefs.decodemorse && (checktype==EVENT_TEXT || checktype==EVENT_QUERY))
  {
    count=checkmorse(part[3]);

    if(count>50)   /* Ab wann wird das als Morsecodes gewertet? */
    {
      char *decoded;

      decoded=0;

      decoded=decodemorse(part[3]);
      if(decoded)
      {
        sprintf(outbuffer,"\\C%dMorse\t%s",COL_PRG,decoded);

        if(checktype==EVENT_TEXT)                     /* Morse aus dem Channel? */
        {
          struct channel *outmorse;

          outmorse=getchannelbyname(server,part[2]); /* Aus welchem Channel kam die Nachricht? */
          displayirc(outbuffer,outmorse);            /* Dekodierte Message dort anzeigen */
        }
        else                                         /* Morse aus dem Query */
        {
          struct node *querynode;
          struct query *outmorse;

          querynode=getquerybyname(server,sendnick); /* Wer hat die Nachricht geschickt? */
          outmorse=querynode->data;

          displayquery(outmorse,outbuffer,part[0]);  /* Dort die dekodierte Message anzeigen */
        }

        free(decoded);
      }
    }
  }

  switch(checktype)
  {
    case EVENT_TEXT:
      if(prefs.channelbell!=0 && bell==1) fl_ringbell(100);   /* die bell==1 Bedingung knnte wohl raus, oder?*/
      checkevents(EVENT_TEXT,sendnick,part[2],part[3]);
    break;

    case EVENT_JOIN:
      checkevents(EVENT_JOIN,sendnick,part[2],sendnick);
    break;

    case EVENT_PART:
      checkevents(EVENT_PART,sendnick,part[2],sendnick);
    break;

    case EVENT_ISON:
      checkevents(EVENT_ISON,sendnick,part[2],part[3]);
    break;

    case EVENT_QUERY:
      if(prefs.querybell!=0)
      {
        if(prefs.queryalwaysbell==1) fl_ringbell(100);
        else if(!isquery(server,sendnick)) fl_ringbell(100);
      }
      checkevents(EVENT_QUERY,sendnick,part[2],part[3]);
    break;

    case EVENT_MODE:
      checkevents(EVENT_MODE,sendnick,part[2],part[3]);
    break;

    case EVENT_INVITE:
      checkevents(EVENT_INVITE,sendnick,(outchannel) ? outchannel->name : 0,part[3]);
    break;

    case EVENT_NICK:
      checkevents(EVENT_NICK,sendnick,(outchannel) ? outchannel->name : 0,part[2]);
    break;
  } // endswitch

}

