/* Preferences.h
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Die Datenstruktur und Name der Voreinstellungsdatei. */

#ifndef PREFERENCES_H
#define PREFERENCES_H

#include "Constants.h"
#include <stdio.h>

struct servernode
{
  struct servernode *next;
  struct servernode *prev;
  
  char name[128];
  char channel[MAXCHANNEL];
  char *password;
  int port;
};

struct geometry
{
  int x;
  int y;
  int w;
  int h;
};

struct preferences
{
  struct servernode *serverlist;
  struct list *ignorelist;
  struct list *aliaslist;

  char prefspath[4096];               // Prefs-Verzeichnis des Users
  char nick[MAXNICKNUM][NICKLEN+1];
  char realname[MAXREAL+1];
  char ident[MAXIDENT+1];
  char quitmsg[LINELEN+1];
  char kickmsg[LINELEN+1];
  char notifystring[LINELEN+1];       // Vielleicht nicht so toll, hier
  char hilightstring[4096];           // eine feste Gre zu nehmen ...
  char nicklistaction[LINELEN+1];     // Doppelklick auf Name in der Nickliste
  char button[8][LINELEN+1];
  char butnam[8][BUTLEN+1];
  char scriptport_i[21];
  char scriptport_o[21];
  char *browsercommand;
  char *cookiefile;
  char *dccpath;
  char *autoawaytext;
  char **actiontitle;
  char **actionlist;

  int scripthandle_i;
  int scripthandle_o;
  int currentversion;
  int numofactions;
  int numofservers;
  int chosenservernum;
  int notifydelay;
  int channelsize;
  int nicksize;
  int initmode;
  int serverpings;
  int motd;
  int fixedmotd;
  int log;
  int logtimestamp;       // Uhrzeit mitloggen?
  int smalllog;           // Logfiles mit Kleinbuchstaben
  int smartcatch;         // URL-Catcher versucht, URLs zu "reinigen"
  int nicknum;            // Momentaner Alternativnick
  int sortnicks;
  int joinoninvite;
  int notify;
  int events;
  int hilight;
  int autonotify;
  int openquery;
  int channelbell;
  int querybell;
  int queryalwaysbell;
  int sketchpad;
  int decodemorse;
  int autoaway;
  int autoawaytime;
  int isaway;
  int color[COL_MAX+1][3];

  struct geometry geomain;         // OK
  struct geometry geoison;         // OK
  struct geometry geonotify;
  struct geometry geoquery;
  struct geometry geoabout;        // OK
  struct geometry geoevent;        // OK
  struct geometry geochannellist;
  struct geometry geotopiclist;
  struct geometry geoerror;
};

struct servernode *addserverprefs(struct preferences *prefs,char *servername);
int freadstr(FILE *handle,char *string);
void getcols(char *string,int *i,int *r,int *g,int *b);
void writeprefs(struct preferences *prefs);
void allocactions(struct preferences *prefs,int numof);
void readprefs(struct preferences *prefs);
void removeserverprefs(struct preferences *prefs,struct servernode *node);
void removeserverprefsnum(struct preferences *prefs,int num);
struct servernode *getservernodebynum(struct preferences *prefs,int num);
void freeactions(struct preferences *prefs);
void freeignore(struct preferences *prefs);
void freeprefs(struct preferences *prefs);

#endif /* PREFERENCES_H */
