/* Scripts.c
   Ein Teil von FoxIRC (C)by Dario Abatianni (eisfuchs@tigress.com)

   Funktionen fr die Skriptverwaltung */

#include <errno.h>
#include <fcntl.h>

#include "Constants.h"
#include "Scripts.h"
#include "Transmit.h"

// #define DEBUG

void openscriptport(struct preferences *prefs)
{
  char tmpname[21];
  int tmphandle,result;

  sprintf(tmpname,"/tmp/FoxIRC_%d_i",getpid());

  result=mkfifo(tmpname,0777);

  if(result) printf("openscriptport(): Konnte eingehenden Skript-Port nicht erstellen! (%s)\n",strerror(errno));
  else
  {
    strcpy(prefs->scriptport_i,tmpname);
#ifdef DEBUG
    printf("*** Skript-Port %s erzeugt\n",prefs->scriptport_i);
#endif

    tmphandle=open(prefs->scriptport_i,O_RDONLY | O_NONBLOCK);
    if(tmphandle==-1)
    {
      printf("doscripts(): Konnte Skript-Port nicht ffnen! (%d %s)\n",errno,strerror(errno));
    }
    else
    {
      prefs->scripthandle_i=tmphandle;
#ifdef DEBUG
      printf("*** Skript-Port %s geffnet\n",prefs->scriptport_i);
#endif
    }
  }

  sprintf(tmpname,"/tmp/FoxIRC_%d_o",getpid());

  result=mkfifo(tmpname,0777);

  if(result) printf("openscriptport(): Konnte ausgehenden Skript-Port nicht erstellen! (%s)\n",strerror(errno));
  else
  {
    strcpy(prefs->scriptport_o,tmpname);
#ifdef DEBUG
    printf("*** Skript-Port %s erzeugt\n",prefs->scriptport_o);
#endif
    tmphandle=open(prefs->scriptport_o,O_WRONLY | O_NONBLOCK);
    if(tmphandle==-1)
    {
      if(errno!=ENXIO) printf("outscript(): Konnte Skript-Port nicht ffnen! (%d %s)\n",errno,strerror(errno));
    }
#ifdef DEBUG
    printf("*** Skript-Port %s geffnet\n",prefs->scriptport_o);
#endif
  }
  prefs->scripthandle_o=tmphandle;
}

void closescriptport(struct preferences *prefs)
{
#ifdef DEBUG
  printf("*** Schliee Skript-Port %s...\n",prefs->scriptport_i);
#endif
  close(prefs->scripthandle_i);
  unlink(prefs->scriptport_i);

#ifdef DEBUG
  printf("*** Schliee Skript-Port %s...\n",prefs->scriptport_o);
#endif
  close(prefs->scripthandle_o);
  unlink(prefs->scriptport_o);
}

void outscript(struct preferences *prefs,unsigned char *string)
{
  int len;

  /* ffne neuen Skript-Port, wenn er noch nicht existiert */
  if(prefs->scripthandle_o==-1) prefs->scripthandle_o=open(prefs->scriptport_o,O_WRONLY | O_NONBLOCK);

  if(prefs->scripthandle_o==-1)
  {
    if(errno!=ENXIO) printf("outscript(): Konnte Skript-Port nicht ffnen! (%d %s)\n",errno,strerror(errno));
  }
  else write(prefs->scripthandle_o,string,strlen(string));
}

void doscripts(struct server *server,struct preferences *prefs)
{
  int len;
  char buffer[LINELEN+1];

  len=read(prefs->scripthandle_i,buffer,LINELEN);
  if(len==-1)
  {
    if(errno!=EAGAIN) printf("doscripts(): Fehler beim Lesen des Skript-Ports! (%d %s)\n",errno,strerror(errno));
  }
  else
  {
    buffer[len]=0;
    /* evtl. angehngtes newline entfernen */
    if(len) if(buffer[len-1]=='\n') buffer[len-1]=0;
    if(strlen(buffer)) transmit(server,buffer);
  }
}
